UNIT uSchuss;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses uNichtLebende,uLebende, uFigur,uGegner,uRespawn, uStart,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, mmsystem, Math;

type
  TSchuss = class(TNichtLebende)

  public //Attribute
    Schaden,startx : Integer;
    vX : Real;

    constructor create(pX, pY, pWidth, pHeight, pSchaden : Integer; pvX : Real; Pfad : String);
    procedure Event(figur : TFigur);override;
    procedure EventGegner(b: Integer);override;
   end;

implementation

uses uMain, uMap;

constructor TSchuss.create(pX, pY, pWidth, pHeight, pSchaden : Integer; pvX : Real; Pfad : String);
Begin
     Schaden := pSchaden;
     vX := pvX;
     startx:=px;
     X := pX;
     Y := pY;

     Picture := TBitmap.Create;
     Picture.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad + '.bmp');

     Width := pWidth;
     Height := pHeight;
     
     PictureInvert := TBitmap.Create;
     PictureInvert.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad +  '_n.bmp');
End;


procedure TSchuss.Event(figur : TFigur);
Var i : Integer;
    gef : Boolean;
Begin
     //Lebenspunkt abziehen
     If figur.Unverwundbar = False then figur.lebenspunkte := figur.lebenspunkte - schaden; // Schaden abziehen

     //Wenn Figur kurz vorherschonmal getroffen und leben verloren hat --> kurze Zeit unverwunbar
     If figur.Lebenspunkte = 1 Then // wenn jetzt nur noch 1 Lebenspunkt --> Unverwundbar fr 5 Sekunden
     Begin
          figur.Unverwundbar := True;
          Form1.tmrUnverwundbar.Enabled := True;
     End;

     If Figur.Lebenspunkte <= 0 Then Begin // wenn keine Lebenspunkte mehr
        Figur.AnzLeben := Figur.AnzLeben - 1; // ein leben abziehen
        Figur.Lebenspunkte := 2;

        If Figur.AnzLeben >= 0 then Begin   //wenn Figur noch lebt, dann suche nach Respawn/Startpunkten
          i := High(NichtLebende);
          gef := False;

          while (i >= 0) and (gef = false) Do Begin
              If (NichtLebende[i] is TRespawn) then Begin
                 If (NichtLebende[i] as TRespawn).Activated = True then Begin
                    Spieler.X := NichtLebende[i].X-250;
                    Spieler.Y := NichtLebende[i].Y;
                    Spieler.vY := 0;
                    zeit := 0;
                    gef := True;
                 End;
              End;
              i := i - 1;
          End;

          If gef = False then Begin    //Wenn keinen Respawnpoint gefunden
          i := High(NichtLebende);     //nimm nen Startpunkt
            while (i >= 0) and (gef = false) Do Begin
                If (NichtLebende[i] is TStart) then Begin
                   Spieler.X := NichtLebende[i].X-250;
                   Spieler.Y := NichtLebende[i].Y;
                   Spieler.vY := 0;
                   zeit := 0;
                   gef := True;
                End;
                i := i - 1;
            End;
          End;
        End
     End;

End;

procedure TSchuss.EventGegner(b: Integer);
var i,a: Integer;
Begin
  if schaden>=10 then
  begin
    //1. Gegner lschen
    zufall:=1+random(7); //von 1 bis 7
    sndplaysound(pchar(ExtractFilePath(ParamStr(0))+'\sounds\gegnertod'+inttostr(zufall)+'.wav'),SND_aSync);
    Gegner[b].Free;
    For a := b to High(Gegner) - 1 Do Begin
      gegner[a] := gegner[a+1];
    End;
    SetLength(gegner,High(gegner));  // letztes lschen

    //fr alle anderen Gegner schauen, ob sie zu nahe an der Exlosion sind!
    i:=0;
    While i<=High(gegner) do
    begin
      if Sqr((gegner[i].X+gegner[i].Width div 2)-(X+Width div 2))+Sqr((gegner[i].Y+gegner[i].Height div 2)-(Y+Height div 2))<Sqr(schaden) then
      begin
        Gegner[i].Free;
        For a := i to High(Gegner) - 1 Do Begin
          gegner[a] := gegner[a+1];
        end;
        SetLength(gegner,High(gegner));
        dec(i);
      end;
      inc(i);
    end;     
    explowo[1]:=(X+Width div 2)-61;
    explowo[2]:=(Y-Height div 2)+61;
    explosion:=true;
  end
  else
  begin
    gegner[b].lebenspunkte := gegner[b].lebenspunkte - schaden;  // Wenn ein Gegner getroffen wird, schadet es ihm
    If Gegner[b].Lebenspunkte <= 0 then Begin
      zufall:=1+random(7); //von 1 bis 7
      sndplaysound(pchar(ExtractFilePath(ParamStr(0))+'\sounds\gegnertod'+inttostr(zufall)+'.wav'),SND_aSync);
      Gegner[b].Free;
      For a := b to High(Gegner) - 1 Do Begin
        gegner[a] := gegner[a+1];
      End;
      SetLength(gegner,High(gegner));  // letztes lschen
    End;
  end;
End;


end.
